///////////////////////////////////////////////////////////////////////////////
/*
                                  build.js

COPYRIGHT
---------
Copyright (C) 2014 Mark G.Daniel
This program, comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under the
conditions of the GNU GENERAL PUBLIC LICENSE, version 3, or any later version.
http://www.gnu.org/licenses/gpl.txt


VERSION
-------
18-APR-2015  MGD  bugfix; mdsiConfigUrl() protocol and host and munge '+'
05-FEB-2014  MGD  initial
*/
///////////////////////////////////////////////////////////////////////////////

var mdsi_AlertsDisplay = false,
    mdsi_ClusterDisplay = false,
    mdsi_CollectDisplay = false,
    mdsi_DiskDisplay = false,
    mdsi_DiskDeltaDisplay = false,
    mdsi_DiskQlenDisplay = false,
    mdsi_HistoryDisplay = false,
    mdsi_InsightDisplay = false,
    mdsi_PerHistoryDisplay = false,
    mdsi_PerProcessPid = 0,
    mdsi_PrevPerProcessPid = 0,
    mdsi_ProcessDisplay = false,
    mdsi_SynopsisDisplay = false,
    mdsi_UpdateDisplay = false;

var mdsi_ThisFrame;

///////////////////////////////////////////////////////////////////////////////
/*
The stand-alone flag is set from a query string element.
*/

function mdsiBuildPage ()
{
   if (mdsiFromQuery().frame)
   {
      /* an iframe (contained by the parent page) */
      if (acme_StandAlone)
      {
         mdsiCSS ('#configAnchor','color','#000000');
         mdsiCSS ('#configControl','color','#000000');

         mdsiCSS ('body','background','transparent');
         mdsiCSS ('#monitor','background','transparent');
         mdsiCSS ('#monitor','border','none');
//         mdsiCSS ('#monitor','border','dotted 1px silver');
         mdsiCSS ('#monitor','box-shadow','none');
         mdsiCSS ('#monitor','padding','5px 15px 0 10px');
      }
      else
      {
         mdsiCSS ('#configAnchor','color','#ffffff');
         mdsiCSS ('#configControl','color','#ffffff');

         mdsiCSS ('body','background','transparent');
         mdsiCSS ('#configAnchor','color','#ffffff');
         mdsiCSS ('#configControl','color','#ffffff');
         mdsiCSS ('#monitor','border','1px outset white');
         mdsiCSS ('#monitor','box-shadow','1px 3px 5px 1px #505050');
         mdsiCSS ('#monitor','padding','10px');
      }
   }
   else
   {
      /* the fundamental parent page (contains the iframes) */
      if (acme_StandAlone)
      {
         mdsiCSS ('#configTitle','color','#ffffff');
         mdsiCSS ('#configTitle','text-shadow',
'0 1px 0 #ccc,\
0 2px 0 #c9c9c9,\
0 3px 0 #bbb,\
0 4px 0 #b9b9b9,\
0 5px 0 #aaa,\
0 6px 1px rgba(0,0,0,.1),\
0 0 5px rgba(0,0,0,.1),\
0 1px 3px rgba(0,0,0,.3),\
0 3px 5px rgba(0,0,0,.2),\
0 5px 10px rgba(0,0,0,.25),\
0 10px 10px rgba(0,0,0,.2),\
0 20px 20px rgba(0,0,0,.15)');
         mdsiCSS ('#configTitle','background-clip','text');

         /** http://www.colorzilla.com/gradient-editor/ **/
         mdsiCSS ('body','background','#eeeeee');
         mdsiCSS ('body','background',
'linear-gradient(135deg, #eeeeee 50%,#b8b8b8 100%)');
      }
      else
      {
         mdsiCSS ('#configTitle','background-clip','text');
         mdsiCSS ('#configTitle','text-shadow',
'0px 1px 2px rgba(255,255,255,.4), -1px -2px 0px rgba(0,0,0,.7)');

         /** http://www.colorzilla.com/gradient-editor/ **/
         mdsiCSS ('body','background','#b5bdc8;');
         mdsiCSS ('body','background',
'linear-gradient(135deg, #b5bdc8 0%,#929ca5 50%,#48545b 100%);');
      }
      mdsiCSS ('body','background-attachment','fixed');
   }


   window.addEventListener('message', acmePostedMessage, false);

   if (mdsiFromQuery().frame)
      acmeLoadFile('monitor.html',mdsiBuildMonitor);
   else
      mdsiBuildMonDeSi();
}

///////////////////////////////////////////////////////////////////////////////
/*
Building the top-level main page.  Generate an iframe for each server to be
monitored.  When the iframe loads it calls acmeBuildIframeLoad() to check the
load success (or otherwise).
*/

function mdsiBuildMonDeSi ()
{
   // Opera (only?) wait for the document to materialise
   if (!document.body)
   {
      setTimeout('mdsiBuildMonDeSi()',250);
      return;
   }

   var  nodes;
   if (!(nodes = mdsiFromQuery().nodes)) 
      nodes = location.protocol + '//' + location.host + location.pathname;
   nodes = nodes.replace(/\n|\r\n|\r/g,'+');
   nodes = nodes.replace(/\+{2,}/g,'+');
   nodes = nodes.replace(/^\+/, '');
   nodes = nodes.replace(/^\+$/, '');
   var these = nodes.split('+');

   var html = '<div>\
\
<div id="configTick">\
<input type="checkbox" onclick="mdsiConfigClick()">\
</div>\
\
<div id="SECTION1" style="display:none">\
<div id="configTitle">MonDeSi</div>\
<form id="configForm">\
<textarea id="configNodes" rows="5" cols="64">';

   for (var idx = 0; idx < these.length; idx++)
      if (these[idx].length) html += these[idx] + '\n';

   html += '</textarea><p>\
<input type="button" class="configBtn" value="Monitor" \
onclick="window.location.replace(mdsiConfigUrl()';

   if (acme_StandAlone) html += '+\'&salone=1\'';

   html += ')">\
<input type="button" class="configBtn" value="Open" \
onclick="mdsiOpenMonDeSi(mdsiConfigUrl()+\'&salone=1\')">\
<input type="button" class="configBtn" value="Link" \
onclick="mdsiLinkClick()">\
<input type="button" class="configBtn" value="Reset" \
onclick="$byId(\'configForm\').reset()">\
<input type="button" class="configBtn" value="Clear" \
onclick="$byId(\'configNodes\').value=\'\'">\
</form>\
<div id="configLink" style="display:none"><a id="configAnchor"></a></div>';

   if (idx > 1)
      html += '<div id="configControl">\
<input type="checkbox" value="none" id="checkboxConfigCollect" \
class="controlCheckbox" checked="checked" onchange="mdsiConfigCollectClick()">\
<label id="controlConfigCollect" for="checkboxConfigCollect">Collect All</label>\
</div>';

   html += '</div>\
<div id="MonDeSi" align="center">';

   for (var idx = 0; idx < these.length; idx++)
   {
      if (!these[idx].length) continue;
      var parts = these[idx].split('?');
      these[idx] = parts[0] + '?frame=' + (idx+1);
      if (acme_StandAlone) these[idx] += '&salone=1';
      if (parts.length > 1) these[idx] += '&' + parts[1];
      acmeIframeCheck(idx+1,these[idx]);
      html += '<iframe id="FRAME' + (idx+1) + '" scrolling="no" \
seamless="seamless" height="0" width="0" src="' + these[idx] + '" \
onload="acmeIframeCheck('+(idx+1)+')">\
</iframe>';
   }
   html += '</div>';

   document.body.innerHTML = html;
}

///////////////////////////////////////////////////////////////////////////////
/*
Send a message to each frame to open/close their WebSocket connection.  Can be
done semi-directly because the configuration panel resides in the top-level
page.
*/

function mdsiConfigCollectClick ()
{
   checked = $byId('checkboxConfigCollect').checked;
   for (var cnt = 0; true; cnt++)
   {
      if (!(obj = $byId('FRAME'+(cnt+1)))) break;
      var json = '{"$ConfigCollect":true,"checked":' + checked + '}';
      obj.contentWindow.postMessage(json,'*');
   }
}

///////////////////////////////////////////////////////////////////////////////
/*
Build the monitor page in an iframe.
*/

function mdsiBuildMonitor (html)
{
   // tell the parent the frame has loaded successfully
   acmeIframeCheck(true);

   mdsi_ThisFrame = 'FRAME' + acmeFrameNumber();

   var body = document.getElementsByTagName('body')[0];

   body.innerHTML = html;

   mdsiBuildControl();
   mdsiBuildDisk();
   mdsiSetHistoryWidth(mdsi_HistWidth5);
   mdsiCollectClick(true);
   mdsiUpdateClick(true);
   mdsiAlertsClick(true);
   mdsiPerHistoryClick(false);
   mdsiMinutesClick(5);

   acmeAdjustSize();

   acmeLoadFile('tips.js','mdsiToolTipInit()');
}

///////////////////////////////////////////////////////////////////////////////
/*
*/

function mdsiConfigClick ()
{
   var ticked = $byId('SECTION1');
   if (ticked.style.display == 'none')
      ticked.style.display = 'block'
   else
      ticked.style.display = 'none'
   if (acme_StandAlone) acmeFitWindow();
}

///////////////////////////////////////////////////////////////////////////////
/*
*/

function mdsiMonitorClick (obj)
{
   var closed = $byId('monitorClosed');
   var open = $byId('monitorOpen');
   if (obj.checked)
   {
      closed.style.display = 'none';
      open.style.display = 'block';
      mdsi_SynopsisDisplay = false;
   }
   else
   {
      closed.style.display = 'block';
      open.style.display = 'none';
      mdsi_SynopsisDisplay = true;
      $byId('closedAlert').innerHTML = '';
      mdsiDisplaySynopsis();
   }
   acmeAdjustSize();
}

///////////////////////////////////////////////////////////////////////////////
/*
Generate the URL, including the query string, used to open the top-level
monitor page.
*/

function mdsiConfigUrl ()
{
   var action = location.protocol + '//' + location.host + $ScriptName;
   var nodes = $byId('configNodes').value;
   nodes = nodes.replace(/\n|\r\n|\r/g,'+');
   nodes = nodes.replace(/\+{2,}/g,'+');
   nodes = nodes.replace(/^\+/, '');
   nodes = nodes.replace(/^\+$/, '');
   var url = action + '?nodes=' + encodeURIComponent(nodes);
   return url;
}

///////////////////////////////////////////////////////////////////////////////
/*
Open a standalone monitor.
*/

function mdsiOpenMonDeSi (url)
{
   if (url)
      window.onerror = function (msg,url,lnum) { alert (msg+' '+url+' '+lnum) };
   else
   {
      if (!document.getElementById('configForm'))
      {
         alert(mdsLangBookmarklet);
         return false;
      }
   }

   var name = new Date();
   name = 'mondesi_' + name.getTime();

   var specs = 'toolbar=0,location=0,directories=0,status=0,' +
               'menubar=0,scrollbars=1,resizable=0,copyhistory=0,' +
               'width=100,height=100';

   window.open((url?url:mdsiConfigUrl()),name,specs);

   return false;
}

///////////////////////////////////////////////////////////////////////////////
/*
Display a link capable of being put into a bookmark and used to directly open a
standalone monitor.
*/

function mdsiLinkClick (change)
{
   var cl = document.getElementById('configLink');
   if (!change)
   {
      if (cl.style.display == 'inline-block')
      {
         cl.style.display = 'none';
         return false;
      }
      cl.style.display = 'inline-block';
   }
   if (cl.style.display != 'inline-block') return false;

   var params = 'status=0,toolbar=0,location=0,menubar=0,resizable=0,' +
                'scrollbars=1,height=100,width=100';
   var href = 'javascript:void(window.open("' + mdsiConfigUrl() +
                               '&salone=1' + '","_blank","' + params + '"))';
   var title = 'MonDeSi ' + $ExeVersion;

   var nodes = $byId('configNodes').value;
   if (nodes.length < 10)
      cl.style.display = 'none';
   else
   {
      var ca = $byId('configAnchor');
      ca.href = ca.innerHTML = href;
      cl.style.display = 'inline-block';
   }

   return false;
}

///////////////////////////////////////////////////////////////////////////////

////////////////////////
// control checkboxes //
////////////////////////

///////////////////////////////////////////////////////////////////////////////
/*
Generate the monitor control check boxes.
*/

function mdsiBuildControl ()
{
   var html = '';
   html += '<table><tr>';

   html += '<td><input type="checkbox" value="none" id="checkboxCollect" \
class="controlCheckbox" onclick="mdsiCollectClick()">\
<label id="controlCollect" for="checkboxCollect">Collect</label></td>';

   html += '<td><input type="checkbox" value="none" id="checkboxUpdate" \
class="controlCheckbox" onclick="mdsiUpdateClick()">\
<label id="controlUpdate" for="checkboxUpdate">Update</label></td>';

   html += '<td><input type="checkbox" value="none" id="checkboxAlerts" \
class="controlCheckbox" onclick="mdsiAlertsClick()">\
<label id="controlAlerts" for="checkboxAlerts">Alerts</label></td>';

   html += '<td><input type="checkbox" value="none" id="checkboxTooltips" \
class="controlCheckbox">\
<label id="controlTips" for="checkboxTooltips">Tips</label></td>';

   html += '<td><input type="checkbox" value="none" id="checkboxHistory" \
class="controlCheckbox" onclick="mdsiHistoryClick()">\
<label id="controlHistory" for="checkboxHistory">History</label></td>';

   html += '<td><input type="checkbox" value="none" id="checkboxMinutes" \
class="controlCheckbox" onclick="mdsiMinutesClick()">\
<label id="controlMinutes" for="checkboxMinutes">5 Minutes</label></td>';

   html += '<td style="width:50%;text-align:right;">\
<input id="zeroBtn" type="button" class="button" \
value="Zero" onclick="mdsiZeroClick();return false;">&nbsp;\
<input id="printBtn" type="button" class="button" \
value="Print" onclick="setTimeout(\'window.print()\',100);return false;">\
</td>';

   html += '</tr><tr>';

   html += '<td><input type="checkbox" value="none" id="checkboxCluster" \
class="controlCheckbox" onclick="mdsiClusterClick()" disabled="true">\
<label id="controlCluster" for="checkboxCluster">Cluster</label></td>';

   html += '<td class="controlCheckbox" colspan="2">\
<input type="checkbox" value="none" id="checkboxDisk" \
class="controlCheckbox" onclick="mdsiDiskClick()" disabled="true">\
<label  style="margin-right:0;" id="controlDisk" \
for="checkboxDisk">Disk</label>&nbsp;\
<input type="checkbox" value="none" id="checkboxDiskQlen" \
class="controlCheckbox" onclick="mdsiDiskQlenClick()" disabled="true">\
<label id="controlDiskQlen" for="checkboxDiskQlen">\u2630</label>\
<input type="checkbox" value="none" id="checkboxDiskDelta" \
class="controlCheckbox" onclick="mdsiDiskDeltaClick()" disabled="true">\
<label id="controlDiskDelta" for="checkboxDiskDelta">\u0394</label></td>';

   html += '<td><input type="checkbox" value="none" id="checkboxProcess" \
class="controlCheckbox" onclick="mdsiProcessClick()" disabled="true">\
<label id="controlProcess" for="checkboxProcess">Process</label></td>';

   html += '</tr></table>';
   $byId('control').innerHTML = html;
}

///////////////////////////////////////////////////////////////////////////////
/*
Collect checkbox has been clicked.
The dollar prefixed version is called from acmePostedMessage().
*/

function $CollectClick (state) { mdsiCollectClick(state) };

function mdsiCollectClick (state)
{
   var cbx = $byId('checkboxCollect');
   if (typeof state != 'undefined') mdsi_CollectDisplay = !state;
   if (mdsi_CollectDisplay)
   {
      mdsi_CollectDisplay = false;
      cbx.checked = false;
      mdsiStreamData(false);
   }
   else
   {
      mdsi_CollectDisplay = true;
      cbx.checked = true;
      mdsiStreamData(true);
      mdsi_CollectStartTime = new Date();
   }
}

///////////////////////////////////////////////////////////////////////////////
/*
Update checkbox has been clicked.
*/

function mdsiUpdateClick (state)
{
   var cbx = $byId('checkboxUpdate');
   if (typeof state != 'undefined') mdsi_UpdateDisplay = !state;
   if (mdsi_UpdateDisplay)
   {
      mdsi_UpdateDisplay = false;
      cbx.checked = false;
   }
   else
   {
      mdsi_UpdateDisplay = true;
      cbx.checked = true;
   }
}

///////////////////////////////////////////////////////////////////////////////
/*
History checkbox has been clicked.
*/

function mdsiHistoryClick (state)
{
   var cbx = $byId('checkboxHistory');
   var htab = $byId('historyDiv');

   if (typeof state != 'undefined') mdsi_HistoryDisplay = !state;

   if (mdsi_HistoryDisplay)
   {
      mdsi_HistoryDisplay = false;
      cbx.checked = false;
      htab.style.display = 'none';
   }
   else
   {
      mdsi_HistoryDisplay = true;
      cbx.checked = true;
      htab.style.display = 'block';
   }

   acmeAdjustSize();
}

///////////////////////////////////////////////////////////////////////////////
/*
The collection/display checkbox has been clicked from 5->15 or 15->5.
The number of seconds to store the data is bumped in the 5->15 transition but
not reset with the 15->5.  Once set it stays that way.
*/

function mdsiMinutesClick (mins)
{
   var cbx = $byId('checkboxMinutes');
   var label = $byId('controlMinutes');

   if ((typeof mins != 'undefined' && mins == 5) ||
       mdsi_HistoryWidth == mdsi_HistWidth15)
   {
      mdsiSetHistoryWidth(mdsi_HistWidth5);
      cbx.checked = true;
      label.innerHTML = '5 Minutes'
   }
   else
   {
      mdsiSetHistoryWidth(mdsi_HistWidth15);
      cbx.checked = true;
      label.innerHTML = '15 Minutes'
   }

   mdsiGraphDynamic();
   if (mdsi_DiskDisplay) mdsiGraphDisk();
   if (mdsi_PerProcessPid) mdsiGraphPerProcess();

   acmeAdjustSize();
}

///////////////////////////////////////////////////////////////////////////////
/*
Alerts checkbox has been clicked.
*/

function mdsiAlertsClick (state)
{
   var cbx = $byId('checkboxAlerts');

   if (typeof state != 'undefined') mdsi_AlertsDisplay = !state;

   if (mdsi_AlertsDisplay)
   {
      mdsi_AlertsDisplay = false;
      cbx.checked = false;
   }
   else
   {
      mdsi_AlertsDisplay = true;
      cbx.checked = true;
   }
}

///////////////////////////////////////////////////////////////////////////////
/*
Disk checkbox has been clicked.
*/

var mdsi_BufferDiskDeltaDisplay = false;
var mdsi_BufferDiskQlenDisplay = false;

function mdsiDiskClick ()
{
   if (mdsi_DiskDisplay)
   {
      mdsi_DiskDisplay = false;
      mdsi_DiskData = null;
      $byId('checkboxDisk').checked = false;
      $byId('perDiskBar').style.display = 'none';
      $byId('perDiskHist').style.display = 'none';
      $byId('checkboxDiskQlen').disabled = true;
      $byId('checkboxDiskDelta').disabled = true;
      mdsi_BufferDiskDeltaDisplay = mdsi_DiskDeltaDisplay;
      mdsi_BufferDiskQlenDisplay = mdsi_DiskQlenDisplay;
   }
   else
   {
      mdsi_DiskDisplay = true;
      $byId('checkboxDisk').checked = true;
      $byId('perDiskBar').style.display = 'block';
      $byId('perDiskHist').style.display = 'block';
      $byId('checkboxDiskQlen').disabled = false;
      $byId('checkboxDiskDelta').disabled = false;
      mdsi_DiskDeltaDisplay = mdsi_BufferDiskDeltaDisplay;
      mdsi_DiskQlenDisplay = mdsi_BufferDiskQlenDisplay;
   }

   if ($WebSocket)
      acmeIpcSend(mdsiTheseData());
   else
      mdsiGraphDisk();
   acmeAdjustSize();
}

///////////////////////////////////////////////////////////////////////////////
/*
Disk queue length checkbox has been clicked.
*/

function mdsiDiskQlenClick ()
{
   if (mdsi_StaticData && !mdsi_StaticData.diskCount) return;

   var cnt = mdsi_StaticData.diskCount;

   mdsi_DiskQlenDisplay = !mdsi_DiskQlenDisplay;

   for (var idx = 0; idx < cnt; idx++)
   {
      $byId('perDiskHistIOPs'+idx).style.display = 'inline-block';
      if (mdsi_DiskQlenDisplay)
         $byId('perDiskHistQlen'+idx).style.display = 'inline-block';
      else
         $byId('perDiskHistQlen'+idx).style.display = 'none';
   }

   mdsiGraphDisk();
   acmeAdjustSize();
}

///////////////////////////////////////////////////////////////////////////////
/*
Disk space delta checkbox has been clicked.
*/

function mdsiDiskDeltaClick ()
{
   if (mdsi_StaticData && !mdsi_StaticData.diskCount) return;

   var cnt = mdsi_StaticData.diskCount;

   mdsi_DiskDeltaDisplay = !mdsi_DiskDeltaDisplay;

   for (var idx = 0; idx < cnt; idx++)
   {
      $byId('perDiskHistIOPs'+idx).style.display = 'inline-block';
      if (mdsi_DiskDeltaDisplay)
         $byId('perDiskHistDelta'+idx).style.display = 'inline-block';
      else
         $byId('perDiskHistDelta'+idx).style.display = 'none';
   }

   mdsiGraphDisk();
   acmeAdjustSize();
}

///////////////////////////////////////////////////////////////////////////////
/*
Process checkbox has been clicked.
*/

function mdsiProcessClick (state)
{
   var cbx = $byId('checkboxProcess');
   var div = $byId('processDiv');

   if (mdsi_ProcessDisplay)
   {
      mdsi_ProcessDisplay = false;
      mdsi_TopProcessData = mdsi_PerProcessData = null;
      mdsiTopPidClick();
      mdsiDisplayTopProcess(true);
      mdsi_PerHistoryDisplay = true;
      mdsiPerHistoryClick(false);
      cbx.checked = false;
      div.style.display = 'none';
   }
   else
   {
      mdsi_ProcessDisplay = true;
      cbx.checked = true;
      div.style.display = 'block';
   }

   if ($WebSocket)
      acmeIpcSend(mdsiTheseData());
   else
      mdsiDisplayTopProcess(false);
   acmeAdjustSize();
}

///////////////////////////////////////////////////////////////////////////////
/*
Cluster checkbox has been clicked.
*/

function mdsiClusterClick ()
{
   var cbx = $byId('checkboxCluster');
   var bar = $byId('clusterBar');
   var hist = $byId('clusterHistory');

   if (mdsi_ClusterDisplay)
   {
      mdsi_ClusterDisplay = false;
      cbx.checked = false;
      bar.style.display = hist.style.display = 'none';
   }
   else
   {
      mdsi_ClusterDisplay = true;
      cbx.checked = true;
      bar.style.display = hist.style.display = 'block';
   }

   if ($WebSocket) acmeIpcSend(mdsiTheseData());
   mdsiDisplaySummary();
   acmeAdjustSize();
}

///////////////////////////////////////////////////////////////////////////////
/*
Generate a parameter string of current interests.  This parameter string is
used to convey interests to the executable via WebSocket IPC and as query
string parameters in the case of XHR requests.
*/

function mdsiTheseData ()
{
   var these = '';

   if ($WebSocket)
   {
      if (mdsi_ClusterDisplay) these += 'cluster=1';
      if (mdsi_DiskDisplay)
      {
         // once disk is enabled don't disable it again
         if (these.length) these += '&';
         these += 'disk=1';
      }
      if (these.length) these += '&';
      if (mdsi_ProcessDisplay)
         these += 'process=1';
      else
         these += 'process=0';
   }
   if (these.length) these += '&';
   these += 'pid=' + mdsi_PerProcessPid + '';

   return(these);
}

///////////////////////////////////////////////////////////////////////////////

